// Some initializations

$(function(){

 if ($("#jubatian_breakout").length != 0){ return; } // Workaround for JQuery ready running twice

 // The order of images must be kept when appending since an array is made of
 // the divs further below without considering their order.

 $("#jsapp-breakout").append('<img id="jubatian_breakout_blocks" src="'+ $("#jsapp-blocks" ).attr("src")+'" style="display: none" />');
 $("#jsapp-breakout").append('<img id="jubatian_breakout_objects" src="'+$("#jsapp-objects").attr("src")+'" style="display: none" />');
 $("#jsapp-breakout").append('<img id="jubatian_breakout_logo" src="'+   $("#jsapp-logo"   ).attr("src")+'" style="display: none" />');
 $("#jsapp-breakout").append('<img id="jubatian_breakout_bg" src="'+     $("#jsapp-gamebg" ).attr("src")+'" style="display: none" />');
 $("#jsapp-breakout").append('<div id="jubatian_breakout"></div>');
 $("#jsapp-breakout").css("width", "640px");

 jubatian_breakout();
});



function jubatian_breakout(){


// Base Z index, the lowest Z occuring on the field. Set it up so the game
// properly integrates in your site. The highest Z is this index + 7.
var jubatian_breakout_zbase=8;



// Tech notes: The jubatian_breakout prefixes are unnecessary, they are left
// here since originally this was not in it's own function. Now as the
// variables are all local nothing would interfere.



var jubatian_breakout_levels=new Array(
 new Array(
  1, 2, 3, 4, 5, 6, 7, 8, 8, 7, 6, 5, 4, 3, 2, 1,
  2, 3, 4, 5, 6, 7, 8, 9, 9, 8, 7, 6, 5, 4, 3, 2,
  3, 4, 5, 6, 7, 8, 9,10,10, 9, 8, 7, 6, 5, 4, 3,
  4, 5, 6, 7, 8, 9,10,11,11,10, 9, 8, 7, 6, 5, 4,
  5, 6, 7, 8, 9,10,11,12,12,11,10, 9, 8, 7, 6, 5,
  4, 5, 6, 7, 8, 9,10,11,11,10, 9, 8, 7, 6, 5, 4,
  3, 4, 5, 6, 7, 8, 9,10,10, 9, 8, 7, 6, 5, 4, 3,
  2, 3, 4, 5, 6, 7, 8, 9, 9, 8, 7, 6, 5, 4, 3, 2,
  1, 2, 3, 4, 5, 6, 7, 8, 8, 7, 6, 5, 4, 3, 2, 1,
  0, 1, 2, 3, 4, 5, 6, 7, 7, 6, 5, 4, 3, 2, 1, 0),
 new Array(
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
 11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0,19,19, 0, 0,19, 0, 0, 0, 0,19, 0, 0,19,19, 0),
 new Array(
  0, 0,15,15,15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0,15,15,15, 5, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0,15, 5, 5, 5, 5, 0, 0, 0, 0,13,13,13, 0, 0, 0,
 15, 5, 5, 5, 5, 5, 5, 0, 0,13,13,13, 1, 1, 0, 0,
 15,19, 5, 5, 5,19, 5, 0, 0,13, 1, 1, 1, 1, 0, 0,
 15,21, 5, 5, 5,21, 5, 0,13, 1, 1, 1, 1, 1, 1, 0,
 15,21, 5, 5, 5,21, 5, 0,13,19, 1, 1, 1,19, 1, 0,
 15, 5, 5, 5, 5, 5, 5, 0,13,21, 1, 1, 1,21, 1, 0,
 15, 5, 5, 5, 5, 5, 5, 0,13,21, 1, 1, 1,21, 1, 0,
 15, 5, 5, 5, 5, 5, 5, 0,13, 1, 1, 1, 1, 1, 1, 0,
 15, 5, 5, 5, 5, 5, 5, 0,13, 1, 1, 1, 1, 1, 1, 0,
 15, 5, 5, 5, 5, 5, 5, 0,13, 1, 1, 1, 1, 1, 1, 0,
 15, 0, 5, 0, 5, 0, 5, 0,13, 1, 1, 1, 1, 1, 1, 0,
 15, 0, 5, 0, 5, 0, 5, 0,13, 1, 1, 1, 1, 1, 1, 0,
  0, 0, 0, 0, 0, 0, 0, 0,13, 0, 1, 0, 1, 0, 1, 0,
  0, 0, 0, 0, 0, 0, 0, 0,13, 0, 1, 0, 1, 0, 1, 0),
 new Array(
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0,20, 0,20, 0,20, 0,20, 0,20, 0, 0, 0, 0, 0, 0,
  0,20, 0,20, 0,20, 0,20, 0,20, 0, 0, 0, 0, 0, 0,
  0,20,20,20,16,20,16,20,20,20, 0, 0, 0, 0, 0, 0,
  0,20,20,20,16,20,16,20,20,20, 0, 0, 0, 0, 0, 0,
  0, 0,16, 9, 9, 9, 8, 9,17, 0, 0, 0, 0, 0, 0, 0,
  0, 0,16, 9, 8, 9, 9, 9,17, 0, 0, 0, 0, 0, 0, 0,
  0, 0,20, 9, 9, 8, 9, 8,21, 0,21, 0,21, 0,21, 0,
  0, 0,20, 8, 9, 9, 9, 9,21, 0,21, 0,21, 0,21, 0,
  0, 0,20, 9, 9, 9, 8, 9,21,17,21,17,21,21,21, 0,
  0, 0,20, 9, 8, 9, 9, 8,21,17,21,17,21,21,21, 0,
  0, 0,16, 8, 9, 9, 9, 9,17, 9, 9, 8, 9,17, 0, 0,
  0, 0,16, 9, 9, 8, 9, 8,17, 8, 9, 9, 9,17, 0, 0,
  0, 0,20, 8, 9, 9, 8, 9,21, 9, 8, 9, 8,21, 0, 0,
  0, 0,20, 9, 8, 9, 9, 9,21, 9, 9, 9, 9,21, 0, 0,
  0, 0,20, 9, 9, 9, 8, 9,21, 8, 9, 8, 9,21, 0, 0,
  0, 0,20, 8, 9, 8, 9, 9,21, 9, 9, 9, 8,21, 0, 0),
 new Array(
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
 10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,
 11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,
 10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,
  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0,20, 0, 0, 0,20, 0, 0,20, 0, 0, 0,20, 0, 0,
 23,23,20, 0, 0, 0,20,23,23,20, 0, 0, 0,20,23,23,
  0, 0,20, 0, 0, 0,20, 0, 0,20, 0, 0, 0,20, 0, 0,
 23,23,20, 0, 0, 0,20,23,23,20, 0, 0, 0,20,23,23,
  0,10,20, 0, 0, 0,20,10,10,20, 0, 0, 0,20,10, 0,
  0, 0,10, 9, 0, 9,10, 0, 0,10, 9, 0, 9,10, 0, 0,
  0, 0, 0,10, 9,10, 0, 0, 0, 0,10, 9,10, 0, 0, 0,
  0, 0, 0, 0,10, 0, 0, 0, 0, 0, 0,10, 0, 0, 0, 0),
 new Array(
  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  1, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  1, 4, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  1, 4, 3, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  1, 4, 3, 6, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  1, 4, 3, 6, 5, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  1, 4, 3, 6, 5, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  1, 4, 3, 6, 5, 8, 7,10, 0, 0, 0, 0, 0, 0, 0, 0,
  1, 4, 3, 6, 5, 8, 7,10, 9, 0, 0, 0, 0, 0, 0, 0,
  1, 4, 3, 6, 5, 8, 7,10, 9,12, 0, 0, 0, 0, 0, 0,
  1, 4, 3, 6, 5, 8, 7,10, 9,12,11, 0, 0, 0, 0, 0,
  1, 4, 3, 6, 5, 8, 7,10, 9,12,11, 2, 0, 0, 0, 0,
  1, 4, 3, 6, 5, 8, 7,10, 9,12,11, 2, 1, 0, 0, 0,
  1, 4, 3, 6, 5, 8, 7,10, 9,12,11, 2, 1, 4, 0, 0,
  1, 4, 3, 6, 5, 8, 7,10, 9,12,11, 2, 1, 4, 3, 0,
  1, 4, 3, 6, 5, 8, 7,10, 9,12,11, 2, 1, 4, 3, 6,
  0, 0, 0,20,20,20,20,20,20,20,20,20,20,20,20, 0),
 new Array(
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0,
  1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12, 0, 0,
  1, 0, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12, 1, 0, 0,
  1, 1, 3, 4, 5, 6, 7, 8, 9,10,11,12, 1, 2, 1, 1,
  0, 0, 4, 5, 6, 7, 8, 9,10,11,12, 1, 2, 3, 1, 0,
  0, 0, 5, 6, 7, 8, 9,10,11,12, 1, 2, 3, 4, 1, 0,
  0, 0, 6, 7, 8, 9,10,11,12, 1, 2, 3, 4, 5, 1, 0,
  1, 1, 7, 8, 9,10,11,12, 1, 2, 3, 4, 5, 6, 1, 1,
  1, 0, 8, 9,10,11,12, 1, 2, 3, 4, 5, 6, 7, 0, 0,
  1, 0, 9,10,11,12, 1, 2, 3, 4, 5, 6, 7, 8, 0, 0,
  1, 0,10,11,12, 1, 2, 3, 4, 5, 6, 7, 8, 9, 0, 0,
  1, 1,11,12, 1, 2, 3, 4, 5, 6, 7, 8, 9,10, 1, 1,
  0, 0,12, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11, 1, 0,
  0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0,
  0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1),
 new Array(
 20,20, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,20,20,
 22, 0, 0, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0,22,
 22, 0, 0, 0, 5, 5, 5, 5, 5, 5, 5, 5, 0, 0, 0,22,
 22, 0, 0, 0, 0, 6, 6, 6, 6, 6, 6, 0, 0, 0, 0,22,
 22, 0, 0, 0, 0, 0, 7, 7, 7, 7, 0, 0, 0, 0, 0,22,
 22, 0, 0, 0, 0, 0, 0,20,20, 0, 0, 0, 0, 0, 0,22,
 22, 0, 0, 0, 0, 0, 0,20,20, 0, 0, 0, 0, 0, 0,22,
 22, 0, 0, 0, 0, 0, 7, 7, 7, 7, 0, 0, 0, 0, 0,22,
 22, 0, 0, 0, 0, 6, 6, 6, 6, 6, 6, 0, 0, 0, 0,22,
 22, 0, 0, 0, 5, 5, 5, 5, 5, 5, 5, 5, 0, 0, 0,22,
 22, 0, 0, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 0, 0,22,
 20,20, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,20,20),
 new Array(
  0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1,
  0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1,
 20,20, 0, 0,20,20, 0, 0,20,20, 0, 0,20,20, 0, 0,
 13,13, 0, 0,13,13, 0, 0,13,13, 0, 0,13,13, 0, 0,
  1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0,
  1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0,
  0, 0,20,20, 0, 0,20,20, 0, 0,20,20, 0, 0,20,20,
  0, 0,13,13, 0, 0,13,13, 0, 0,13,13, 0, 0,13,13,
  0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1,
  0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0,
  0, 0, 1,13,13, 1, 0, 0, 0, 0, 1,13,13, 1, 0, 0,
  0, 0, 1,13,13, 1, 0, 0, 0, 0, 1,13,13, 1, 0, 0,
  0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0),
 new Array(
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
 12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,
 11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,
 10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,
  9, 0, 9, 0, 9, 0, 9, 0, 0, 9, 0, 9, 0, 9, 0, 9,
  9, 0, 9, 0, 9, 0,21, 0, 0,21, 0, 9, 0, 9, 0, 9,
  9, 0, 9, 0,21, 0, 0, 0, 0, 0, 0,21, 0, 9, 0, 9,
  9, 0,21, 0, 0, 0, 0,10,10, 0, 0, 0, 0,21, 0, 9,
 21, 0, 0, 0, 0, 0,10,11,11,10, 0, 0, 0, 0, 0,21,
  0, 0, 0, 0, 0,10,11,12,12,11,10, 0, 0, 0, 0, 0,
  0, 0, 0, 0,10,11,12, 1, 1,12,11,10, 0, 0, 0, 0,
  0, 0, 0, 0, 0,10,11,12,12,11,10, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0,10,11,11,10, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0,10,10, 0, 0, 0, 0, 0, 0, 0),
 new Array(
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0,20,20, 0, 0, 3, 3, 3, 2, 0, 0,20,20, 0, 0,
  0, 0,22, 0, 0, 2, 3, 3, 2, 3, 3, 0, 0,22, 0, 0,
  0, 0,22, 0, 3, 3, 2, 3, 3, 3, 2, 3, 0,22, 0, 0,
  0, 0,22, 2, 3, 3, 3, 3, 2, 3, 3, 3, 2,22, 0, 0,
  0, 0,22, 3, 3, 2, 3, 3, 3, 2, 3, 3, 3,22, 0, 0,
  0, 0,22, 2, 3, 3, 2, 3, 2, 3, 3, 2, 3,22, 0, 0,
  0, 0,22, 3, 2, 3, 3, 3, 3, 3, 2, 3, 3,22, 0, 0,
  0, 0,22, 3, 3, 3, 2, 3, 2, 3, 3, 3, 2,22, 0, 0,
  0, 0,22, 2, 3, 2, 3, 2, 3, 3, 2, 3, 3,22, 0, 0,
  0, 0,20,23,23,23,23,23,23,23,23,23,23,20, 0, 0,
  0, 0, 0, 0, 0,21, 0, 0, 0, 0,21, 0, 0, 0, 0, 0,
  0, 0, 0, 0,21,21,21, 0, 0,21,21,21, 0, 0, 0, 0,
  0, 0, 0, 0,21,21,21, 0, 0,21,21,21, 0, 0, 0, 0,
  0, 0, 0, 0,21,21,21, 0, 0,21,21,21, 0, 0, 0, 0,
 14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,
  0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2),
 new Array(
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 0,
  0, 5, 5, 5, 5, 4, 3, 3, 3, 3, 4, 5, 5, 5, 5, 0,
  0, 5, 5, 4, 3, 3, 3, 3, 3, 3, 3, 3, 4, 5, 5, 0,
  0, 5, 5, 3, 3, 4, 5, 5, 5, 5, 4, 3, 3, 5, 5, 0,
  0, 5, 4, 3, 4, 4, 5, 5, 5, 5, 4, 4, 3, 4, 5, 0,
  0, 5, 3, 3, 5, 3, 4, 5, 5, 4, 3, 5, 3, 3, 5, 0,
  0, 5, 3, 4, 5, 3, 4, 5, 5, 4, 3, 5, 4, 3, 5, 0,
  0, 5, 3, 5, 5, 4, 5, 5, 5, 5, 4, 5, 5, 3, 5, 0,
  0, 5, 3, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 3, 5, 0,
  0, 5, 3, 5, 3, 4, 5, 5, 5, 5, 4, 3, 5, 3, 5, 0,
  0, 5, 3, 4, 4, 3, 4, 5, 5, 4, 3, 4, 4, 3, 5, 0,
  0, 5, 3, 3, 5, 4, 3, 3, 3, 3, 4, 5, 3, 3, 5, 0,
  0, 5, 4, 3, 4, 5, 5, 5, 5, 5, 5, 4, 3, 4, 5, 0,
  0, 5, 5, 3, 3, 4, 5, 5, 5, 5, 4, 3, 3, 5, 5, 0,
  0, 5, 5, 4, 3, 3, 3, 3, 3, 3, 3, 3, 4, 5, 5, 0,
  0, 5, 5, 5, 5, 4, 3, 3, 3, 3, 4, 5, 5, 5, 5, 0,
  0, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 0),
 new Array(
  9, 9, 9, 9,10,11, 0, 0, 0, 0,11,10, 9, 9, 9, 9,
  9, 9, 9,10,11, 0, 0, 0, 0, 0, 0,11,10, 9, 9, 9,
  9, 9,10,11, 0, 0, 0, 0, 0, 0, 0, 0,11,10, 9, 9,
  9,10,11, 0, 0,20,20,20,20,20,20, 0, 0,11,10, 9,
 10,11, 0, 0, 0, 0,22, 0, 0,22, 0, 0, 0, 0,11,10,
 11, 0, 0, 0, 0, 0,22, 0, 0,22, 0, 0, 0, 0, 0,11,
  0, 0, 0, 0, 0, 0,22, 0, 0,22, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0,22, 0, 0,22, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0,20,20,20,20,20,20, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0,10, 9, 9, 9, 9,10, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0,11,10, 9, 9,10,11, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0,11, 0,10,10, 0,11, 0, 0, 0, 0, 0,
  0,20,20, 0, 0, 0, 0,11,11, 0, 0, 0, 0,20,20, 0,
  0, 0, 0, 0, 0, 0, 0,11,11, 0, 0, 0, 0, 0, 0, 0),
 new Array(
  0, 9, 0, 9, 0, 9, 0, 9, 0, 9, 0, 9, 0, 9, 0, 9,
  0,10, 0,10, 0,10, 0,10, 0,10, 0,10, 0,10, 0,10,
  0,11, 0,11, 0,11, 0,11, 0,11, 0,11, 0,11, 0,11,
  0,12, 0,12, 0,12, 0,12, 0,12, 0,12, 0,12, 0,12,
  0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1,
  0,20, 0,20, 0,20, 0,20, 0,20, 0,20, 0,20, 0,20,
  2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0,
  3, 0, 3, 0, 3, 0, 3, 0, 3, 0, 3, 0, 3, 0, 3, 0,
  0, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
  0, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0, 5, 0,
  0, 0, 0, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
  0, 0, 0, 0, 7, 0, 7, 0, 7, 0, 7, 0, 7, 0, 7, 0,
  0, 0, 0, 0, 0, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
  0, 0, 0, 0, 0, 0, 9, 0, 9, 0, 9, 0, 9, 0, 9, 0,
  0, 0, 0, 0, 0, 0, 0,10,10,10,10,10,10,10,10,10,
  0, 0, 0, 0, 0, 0, 0, 0,11, 0,11, 0,11, 0,11, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0,12,12,12,12,12, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0),
 new Array(
  9, 9, 9, 9, 9, 9, 0, 0, 0, 0, 9, 9, 9, 9, 9, 9,
  9, 9, 9, 9, 9, 0, 0, 0, 0, 0, 0, 9, 9, 9, 9, 9,
 10,10,10,10,10, 0, 0, 0, 0, 0, 0,10,10,10,10,10,
 11,11,11,11,11, 0, 0, 0, 0, 0, 0,11,11,11,11,11,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9,
  8, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 8,
  7, 8, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 8, 7,
  8, 7, 8, 9, 0, 0, 0, 0, 0, 0, 0, 0, 9, 8, 7, 8,
  9, 8, 7, 8, 9, 0, 0, 0, 0, 0, 0, 9, 8, 7, 8, 9,
  0, 9, 8, 7, 8, 9, 0, 0, 0, 0, 9, 8, 7, 8, 9, 0,
  0, 0,21,21,21,21,21, 0, 0,21,21,21,21,21, 0, 0));
  
  
var jubatian_breakout_game;

var jubatian_breakout_pfx=8; // Playfield X location (512x384 area)
var jubatian_breakout_pfy=8; // Playfield Y location

var jubatian_breakout_lfx=540; // Life bar X location (Vertical, 9x120 area)
var jubatian_breakout_lfy=120;

var jubatian_breakout_bnx=580; // Bonus effect bar X (Vertical, 17x120 area)
var jubatian_breakout_bny=120;

var jubatian_breakout_inx=530; // Info board locations (Score & help text)
var jubatian_breakout_iny=260; // 100px wide, help field is 20px below.











// Resources - used by all

function jubatian_breakout_Resources(){
 this.clearcss={ margin: "0px", padding: "0px", border: "0px", overflow: "hidden", backgroundColor: "transparent", backgroundImage: "none"};
 this.divstart='<div style="position: absolute; margin: 0px; padding: 0px; border: 0px;';
}

function jubatian_breakout_Resources_img(){
 var img=$("#jubatian_breakout_blocks, #jubatian_breakout_objects, #jubatian_breakout_logo, #jubatian_breakout_bg").get();
 this.bgblocks= "background-image: url('"+img[0].src+"');";
 this.bgobjects="background-image: url('"+img[1].src+"');";
 this.logo=img[2].src;
 this.bg=img[3].src;
}
jubatian_breakout_Resources.prototype.img=jubatian_breakout_Resources_img;

// Game field positioning - all areas
function jubatian_breakout_Resources_loc(px,py,lx,ly,bx,by,ix,iy){
 this.pfx=px; this.pfy=py;
 this.lfx=lx; this.lfy=ly;
 this.bnx=bx; this.bny=by;
 this.inx=ix; this.iny=iy;
}
jubatian_breakout_Resources.prototype.loc=jubatian_breakout_Resources_loc;

var jubatian_breakout_res=new jubatian_breakout_Resources();
jubatian_breakout_res.loc(
 jubatian_breakout_pfx,jubatian_breakout_pfy,
 jubatian_breakout_lfx,jubatian_breakout_lfy,
 jubatian_breakout_bnx,jubatian_breakout_bny,
 jubatian_breakout_inx,jubatian_breakout_iny
);









// Returns a free element's index of arrays which have the 'a' member
// (Should have been done with inheritance, but this JS is just silly at OOP)
function jubatian_breakout_free(array)
{
 for(var i=0; i<array.length; i++) if (!array[i].a) return i;
 return array.length;
}










// Info board
function jubatian_breakout_Info(){
 $(jubatian_breakout_res.divstart+
   'width: 100px;'+
   'left: '+jubatian_breakout_res.inx+'px;'+'top: '+jubatian_breakout_res.iny+'px;'+
   'text-align: center; font-size: 12px; color: #dddddd;'+
   '" id="jubatian_breakout_c"></div>').appendTo("#jubatian_breakout");
 this.sdiv=$("#jubatian_breakout_c");
 this.sdiv.removeAttr("id");
 $(jubatian_breakout_res.divstart+
   'width: 100px;'+
   'left: '+jubatian_breakout_res.inx+'px;'+'top: '+(jubatian_breakout_res.iny+20)+'px;'+
   'text-align: center; font-size: 10px; color: #dddddd;'+
   '" id="jubatian_breakout_c"></div>').appendTo("#jubatian_breakout");
 this.hdiv=$("#jubatian_breakout_c");
 this.hdiv.removeAttr("id");
}

// Removes info board
function jubatian_breakout_Info_remove(){ this.sdiv.remove(); this.hdiv.remove(); }
jubatian_breakout_Info.prototype.remove=jubatian_breakout_Info_remove;

// Adds score
function jubatian_breakout_Info_score(score){ this.sdiv.text(score); }
jubatian_breakout_Info.prototype.score=jubatian_breakout_Info_score;

// Adds help
function jubatian_breakout_Info_help(help){ this.hdiv.text(help); }
jubatian_breakout_Info.prototype.help=jubatian_breakout_Info_help;









// Generic object for the life bar & bonus lists
function jubatian_breakout_Stacked(){
 this.a=false;
 this.y=0;
 this.div=null;
 this.type=0;  // Unused here, this is for bonuses
}

function jubatian_breakout_Stacked_update(){
 if(!this.a) return;
 var top=Math.floor(this.y);
 this.div.css({top: top+"px"});
}
jubatian_breakout_Stacked.prototype.update=jubatian_breakout_Stacked_update;

// Creates div & enable
// x: X position (fixed)
// y: Initial Y position
// w,h: Dimensions of div
// bgx: Offset of graphics on the objects picture (positive)
function jubatian_breakout_Stacked_crdiv(x,y,w,h,bgx){
 $(jubatian_breakout_res.divstart+jubatian_breakout_res.bgobjects+
   'width: '+w+'px; height: '+h+'px;'+
   'background-position: -'+bgx+'px 0px;'+
   'left: '+x+'px;'+'top: '+y+'px;'+
   '" id="jubatian_breakout_c"></div>').appendTo("#jubatian_breakout");
 this.div=$("#jubatian_breakout_c");
 this.div.removeAttr("id");
 this.y=y;
 this.a=true;
}
jubatian_breakout_Stacked.prototype.crdiv=jubatian_breakout_Stacked_crdiv;

// Removes div
function jubatian_breakout_Stacked_remove(){ this.div.remove(); this.a=false; }
jubatian_breakout_Stacked.prototype.remove=jubatian_breakout_Stacked_remove;

// Exchanges two elements
function jubatian_breakout_Stacked_xchg(stk){
 t=this.a; this.a=stk.a; stk.a=t;
 t=this.y; this.y=stk.y; stk.y=t;
 t=this.div; this.div=stk.div; stk.div=t;
 t=this.type; this.type=stk.type; stk.type=t;
}
jubatian_breakout_Stacked.prototype.xchg=jubatian_breakout_Stacked_xchg;










var jubatian_breakout_lifebar_array=new Array();

// Adds a new life to the list
function jubatian_breakout_lifebar_add(){
 var tl=new jubatian_breakout_Stacked();
 tl.crdiv(jubatian_breakout_res.lfx,jubatian_breakout_res.lfy,9,9,231);
 jubatian_breakout_lifebar_array.push(tl);
}

// Removes a life from the list. Returns false if no more to remove.
function jubatian_breakout_lifebar_rem(){
 if (jubatian_breakout_lifebar_array.length){
  var t=jubatian_breakout_lifebar_array.shift();
  t.remove();
  return true;
 }
 return false;
}

// Processes a frame on the life bar. This involves slowly moving down
// elements which can be moved.
function jubatian_breakout_lifebar_frame(){
 if (!jubatian_breakout_lifebar_array.length) return;
 if (jubatian_breakout_lifebar_array[0].y<jubatian_breakout_res.lfy+111){
  jubatian_breakout_lifebar_array[0].y++;
  jubatian_breakout_lifebar_array[0].update();
 }
 for (var i=1; i<jubatian_breakout_lifebar_array.length; i++){
  if (jubatian_breakout_lifebar_array[i].y<jubatian_breakout_lifebar_array[i-1].y-9){
   jubatian_breakout_lifebar_array[i].y++;
   jubatian_breakout_lifebar_array[i].update();
  }
 }
}










var jubatian_breakout_bonusbar_array=new Array();

// Adds a new bonus to the list
function jubatian_breakout_bonusbar_add(type){
 for (var i=0; i<jubatian_breakout_bonusbar_array.length; i++)
  if (jubatian_breakout_bonusbar_array[i].type==type) return; // Already listed
 var tl=new jubatian_breakout_Stacked();
 tl.crdiv(jubatian_breakout_res.bnx,jubatian_breakout_res.bny,17,17,type*17);
 tl.type=type;
 jubatian_breakout_bonusbar_array.push(tl);
}

// Removes a bonus from the list.
function jubatian_breakout_bonusbar_rem(type){
 var i=0;
 for (; i<jubatian_breakout_bonusbar_array.length; i++)
  if (jubatian_breakout_bonusbar_array[i].type==type) break;
 if (i==jubatian_breakout_bonusbar_array.length) return; // Not found
 i++;
 for (; i<jubatian_breakout_bonusbar_array.length; i++)
  jubatian_breakout_bonusbar_array[i].xchg(jubatian_breakout_bonusbar_array[i-1]);
 var t=jubatian_breakout_bonusbar_array.pop();
 t.remove();
}

// Processes a frame on the bonus bar. This involves slowly moving down
// elements which can be moved.
function jubatian_breakout_bonusbar_frame(){
 if (!jubatian_breakout_bonusbar_array.length) return;
 if (jubatian_breakout_bonusbar_array[0].y<jubatian_breakout_res.bny+103){
  jubatian_breakout_bonusbar_array[0].y++;
  jubatian_breakout_bonusbar_array[0].update();
 }
 for (var i=1; i<jubatian_breakout_bonusbar_array.length; i++){
  if (jubatian_breakout_bonusbar_array[i].y<jubatian_breakout_bonusbar_array[i-1].y-17){
   jubatian_breakout_bonusbar_array[i].y++;
   jubatian_breakout_bonusbar_array[i].update();
  }
 }
}











// Brick class - the breakable bricks
// Objects of this class refer to bricks on the playfield
// the passed playfield object's brickno propety will be matained according to
// the number of destructable (with 1 force) bricks.
// the passed bonus array is in which to generate bonuses.

function jubatian_breakout_Brick(type,x,y,field,bonus){
 if (type==0){ this.type=0; return; }
 $(jubatian_breakout_res.divstart+jubatian_breakout_res.bgblocks+
   'width: 32px; height: 16px;'+
   'left:'+(x*32+jubatian_breakout_res.pfx)+'px;'+
   'top:' +(y*16+jubatian_breakout_res.pfy)+'px;'+
   'background-position: 0px -'+((type-1)*16)+'px;'+
   '" id="jubatian_breakout_c"></div>').appendTo("#jubatian_breakout");
 this.type=type;
 this.div=$("#jubatian_breakout_c");
 this.div.removeAttr("id");
 this.x=x;
 this.y=y;
 this.field=field;
 this.bonus=bonus;
 if ((this.type>0) && (this.type<19)) field.brickno++;
}

// Hit: what happens when the brick is hit by something (Ball, probably missile later...)
// force is the hit strength. 1 is for normal ball. (Now just ignored; later...)
// Returns true if block was removed (empty areas too), false else
function jubatian_breakout_Brick_hit(force){
 if (this.type==0) return true;
 if ((this.type<19) || (force>1)){
  if (this.type<19) this.field.brickno--;
  this.div.remove();
  var prob=Math.floor(Math.random()*200);
  var typ; // Bonus to generate

  switch(prob){
   case 0:        typ=0;  break; // Bad stuff remove: 0.5%
   case 1:  case 2:  case 3:
   case 4:        typ=1;  break; // Extra ball: 2%
   case 5:  case 6:  case 7:  case 8:  case 9:
   case 10:       typ=2;  break; // Size increase: 3%
   case 11: case 12:
   case 13:       typ=3;  break; // Magnet: 1.5%
   case 14: case 15:
   case 16:       typ=4;  break; // Slow: 1.5%
   case 17:       typ=5;  break; // Shooter: 0.5%
   case 18:       typ=6;  break; // Super ball: 0.5%
   case 19: case 20: case 21: case 22: case 23:
   case 24:       typ=7;  break; // Bonus killer: 3%
   case 25: case 26: case 27: case 28: case 29:
   case 30:       typ=8;  break; // Size decrease: 3%
   case 31: case 32: case 33:
   case 34:       typ=9;  break; // Fast: 2%
   case 35: case 36:
   case 37:       typ=10; break; // Inverter: 1.5%
   case 38:       typ=11; break; // Bomb: 0.5%
   case 39:       typ=12; break; // Rocket: 0.5%
   default:       typ=-1;
  }
  if (typ>=0) this.bonus[jubatian_breakout_free(this.bonus)]=new jubatian_breakout_Bonus(typ,this.x*32+16,this.y*16+8);
  
  this.type=0;
  return true;
 }
 return false;
}
jubatian_breakout_Brick.prototype.hit=jubatian_breakout_Brick_hit;

function jubatian_breakout_Brick_remove(){ if (this.type) this.div.remove(); }
jubatian_breakout_Brick.prototype.remove=jubatian_breakout_Brick_remove;










// Playfield class - a set of bricks
// Constructor source is an one dimensional array of brick types.
// bonus is the array in which bonuses should be generated.

function jubatian_breakout_Playfield(source,bonus){
 this.pf=new Array();
 this.brickno=0;
 for (var i=0; i<source.length; i++)
  this.pf[i]=new jubatian_breakout_Brick(source[i], i%16,Math.floor(i/16),this,bonus);
}

// Returns brick object at the given brick location, null if none.
function jubatian_breakout_Playfield_get(x,y)
{
 if ((x+y*16)>=this.pf.length) return null;
 return this.pf[x+y*16];
}
jubatian_breakout_Playfield.prototype.get=jubatian_breakout_Playfield_get;

// Removes playfield - clears bricks
function jubatian_breakout_Playfield_remove()
{ for (var i=0; i<this.pf.length; i++) this.pf[i].remove(); }
jubatian_breakout_Playfield.prototype.remove=jubatian_breakout_Playfield_remove;









// Missile class - shoot' em!
// Never attached, these fire immediately, going up
// The paddle object is which fires the missile (Determines start position)
// lf if true, the missile will fire from left end, otherwise right end.

function jubatian_breakout_Missile(paddle, lf)
{
 var df=(paddle.w/2)-6;
 if (lf) df=-df;
 this.x=paddle.x+df;
 this.y=paddle.bally();
 this.a=true;
 $(jubatian_breakout_res.divstart+
   'width: 1px; height: 5px;'+
   'background-color: #ffeecc;'+
   'left: '+(this.x+jubatian_breakout_res.pfx)+'px;'+
   'top: ' +(this.y+jubatian_breakout_res.pfy)+'px;'+
   '" id="jubatian_breakout_c"></div>').appendTo("#jubatian_breakout");
 this.div=$("#jubatian_breakout_c");
 this.div.removeAttr("id");
}

// Updates the missile's div.
function jubatian_breakout_Missile_update()
{
 if (!this.a) return;
 var top=Math.floor(this.y)+jubatian_breakout_res.pfy;
 this.div.css({top: top+"px"});
}
jubatian_breakout_Missile.prototype.update=jubatian_breakout_Missile_update;

// Removes missile
function jubatian_breakout_Missile_remove(){ this.div.remove(); this.a=false; }
jubatian_breakout_Missile.prototype.remove=jubatian_breakout_Missile_remove;











// Bomb class - blast'em!
// Never attached, fires immediately, going up
// The paddle object is which fires the missile (Determines start position).

function jubatian_breakout_Bomb(paddle)
{
 this.x=paddle.ballx();
 this.y=paddle.bally();
 this.a=true;
 $(jubatian_breakout_res.divstart+jubatian_breakout_res.bgobjects+
   'width: 7px; height: 15px;'+
   'background-position: -224px 0px;'+
   'left: '+(this.x+jubatian_breakout_res.pfx-4)+'px;'+
   'top: ' +(this.y+jubatian_breakout_res.pfy)  +'px;'+
   '" id="jubatian_breakout_c"></div>').appendTo("#jubatian_breakout");
 this.div=$("#jubatian_breakout_c");
 this.div.removeAttr("id");
}

// Updates the bomb's div.
function jubatian_breakout_Bomb_update()
{
 if (!this.a) return;
 var top=Math.floor(this.y)+jubatian_breakout_res.pfy;
 this.div.css({top: top+"px"});
}
jubatian_breakout_Bomb.prototype.update=jubatian_breakout_Bomb_update;

// Removes bomb
function jubatian_breakout_Bomb_remove(){ this.div.remove(); this.a=false; }
jubatian_breakout_Bomb.prototype.remove=jubatian_breakout_Bomb_remove;










// Rocket class
// Never attached, fires immediately, going up
// The paddle object is which fires the missile (Determines start position).

function jubatian_breakout_Rocket(paddle)
{
 this.x=paddle.ballx();
 this.y=paddle.bally();
 this.a=true;
 $(jubatian_breakout_res.divstart+
   'width: 1px; height: 20px;'+
   'left: '+(this.x+jubatian_breakout_res.pfx)+'px;'+
   'top: ' +(this.y+jubatian_breakout_res.pfy)+'px;'+
   'background-color: #ffdd55;'+
   '" id="jubatian_breakout_c"></div>').appendTo("#jubatian_breakout");
 this.div=$("#jubatian_breakout_c");
 this.div.removeAttr("id");
}

// Updates the rocket's div.
function jubatian_breakout_Rocket_update()
{
 if (!this.a) return;
 var top=Math.floor(this.y)+jubatian_breakout_res.pfy;
 this.div.css({top: top+"px"});
}
jubatian_breakout_Rocket.prototype.update=jubatian_breakout_Rocket_update;

// Removes rocket
function jubatian_breakout_Rocket_remove(){ this.div.remove(); this.a=false; }
jubatian_breakout_Rocket.prototype.remove=jubatian_breakout_Rocket_remove;











// Ball class - one ball
// A ball initially starts out being attached to a paddle object which is
// passed here.

function jubatian_breakout_Ball(paddle)
{
 this.attach=paddle; // On paddle
 this.x=0;
 this.y=paddle.bally();
 this.vx=0;
 this.vy=0;
 $(jubatian_breakout_res.divstart+jubatian_breakout_res.bgobjects+
   'width: 9px; height: 9px;'+
   'background-position: -231px 0px;'+
   '" id="jubatian_breakout_c"></div>').appendTo("#jubatian_breakout");
 this.div=$("#jubatian_breakout_c");
 this.div.removeAttr("id");
 this.a=true;
}

// Updates the ball's div.
function jubatian_breakout_Ball_update()
{
 if (!this.a) return;
 var xp=this.x;
 if (this.attach){
  xp=this.attach.ballx()+this.x;
  this.y=this.attach.bally();
 }
 var left=Math.floor(xp    )-5+jubatian_breakout_res.pfx;
 var top= Math.floor(this.y)-5+jubatian_breakout_res.pfy;
 this.div.css({left: left+"px", top: top+"px"});
}
jubatian_breakout_Ball.prototype.update=jubatian_breakout_Ball_update;

// Removes ball
function jubatian_breakout_Ball_remove(){ this.div.remove(); this.a=false; }
jubatian_breakout_Ball.prototype.remove=jubatian_breakout_Ball_remove;

// Attaches ball to paddle
function jubatian_breakout_Ball_pattach(paddle){
 this.attach=paddle;
 this.x-=paddle.ballx();
}
jubatian_breakout_Ball.prototype.pattach=jubatian_breakout_Ball_pattach;

// Releases ball (making it's x available)
function jubatian_breakout_Ball_release(){
 this.x+=this.attach.ballx();
 this.attach=null;
}
jubatian_breakout_Ball.prototype.release=jubatian_breakout_Ball_release;











// Bonus class - falling bonuses
// These objects slowly fall down after a block vanishes.
// x & y are the initial locations (y will increment as it falls)
// type ranges from 0 to 8 (Here this just selects shape)

function jubatian_breakout_Bonus(type,x,y)
{
 this.x=x;
 this.y=y;
 this.type=type;
 $(jubatian_breakout_res.divstart+jubatian_breakout_res.bgobjects+
   'width: 17px; height: 17px;'+
   'background-position: -'+(type*17)+'px 0px;'+
   'left: '+(x+jubatian_breakout_res.pfx-8)+'px;'+
   'top: ' +(y+jubatian_breakout_res.pfy-8)+'px;'+
   '" id="jubatian_breakout_c"></div>').appendTo("#jubatian_breakout");
 this.div=$("#jubatian_breakout_c");
 this.div.removeAttr("id");
 this.a=true;
}

// Advances a frame - uses the given fall speed.
function jubatian_breakout_Bonus_frame(spd){ this.y+=spd; }
jubatian_breakout_Bonus.prototype.frame=jubatian_breakout_Bonus_frame;

// Updates the bonus's div.
function jubatian_breakout_Bonus_update()
{
 if (!this.a) return;
 var top= Math.floor(this.y)-8+jubatian_breakout_res.pfy;
 this.div.css({top: top+"px"});
}
jubatian_breakout_Bonus.prototype.update=jubatian_breakout_Bonus_update;

// Removes bonus
function jubatian_breakout_Bonus_remove(){ this.div.remove(); this.a=false; }
jubatian_breakout_Bonus.prototype.remove=jubatian_breakout_Bonus_remove;











// Paddle class
// w is the initial paddle width

function jubatian_breakout_Paddle(x,y,w)
{
 this.x=x;
 this.y=y;
 this.w=w;
 this.wt=w;
 $(jubatian_breakout_res.divstart+jubatian_breakout_res.bgobjects+
   'width: 42px; height: 13px;'+
   'background-position: -240px 0px;'+
   '" id="jubatian_breakout_c"></div>').appendTo("#jubatian_breakout");
 this.divl=$("#jubatian_breakout_c"); // Paddle left
 this.divl.removeAttr("id");
 $(jubatian_breakout_res.divstart+jubatian_breakout_res.bgobjects+
   'width: 42px; height: 13px;'+
   'background-position: -258px 0px;'+
   '" id="jubatian_breakout_c"></div>').appendTo("#jubatian_breakout");
 this.divr=$("#jubatian_breakout_c"); // Paddle right
 this.divr.removeAttr("id");
 this.a=true;
}

// Updates paddle div
function jubatian_breakout_Paddle_update(){
 if (!this.a) return;
 var left= Math.floor(this.x-(this.w/2))   +jubatian_breakout_res.pfx;
 var right=Math.floor(this.x+(this.w/2))-42+jubatian_breakout_res.pfx;
 var top=  Math.floor(this.y)-6+jubatian_breakout_res.pfy;
 this.divl.css({left: left +"px", top: top+"px"});
 this.divr.css({left: right+"px", top: top+"px"});
}
jubatian_breakout_Paddle.prototype.update=jubatian_breakout_Paddle_update;

// Returns ball x/y position if attached to paddle
function jubatian_breakout_Paddle_ballx(){ return this.x; }
function jubatian_breakout_Paddle_bally(){ return this.y-10; }
jubatian_breakout_Paddle.prototype.ballx=jubatian_breakout_Paddle_ballx;
jubatian_breakout_Paddle.prototype.bally=jubatian_breakout_Paddle_bally;

// Sets a change size target
function jubatian_breakout_Paddle_size(w){ this.wt=w; }
jubatian_breakout_Paddle.prototype.size=jubatian_breakout_Paddle_size;

// Processes a frame of size change (if any)
function jubatian_breakout_Paddle_frame(){
 if (this.wt==this.w) return;
 if (this.wt>this.w){ this.w++; return; }
 if (this.wt<this.w){ this.w--; return; }
}
jubatian_breakout_Paddle.prototype.frame=jubatian_breakout_Paddle_frame;

// Removes a paddle
function jubatian_breakout_Paddle_remove(){ this.divl.remove(); this.divr.remove(); this.a=false; }
jubatian_breakout_Paddle.prototype.remove=jubatian_breakout_Paddle_remove;

// Collision test with paddle (balls / bonuses)
// Returns true on collision
function jubatian_breakout_Paddle_collide(x,y){
 if ( (x>(this.x-(this.w/2))) && (x<(this.x+(this.w/2))) && (y>(this.y-7)) && (y<(this.y+7)) ) return true;
 return false;
}
jubatian_breakout_Paddle.prototype.collide=jubatian_breakout_Paddle_collide;












// Game object - keeps track of a game on one level
// constructor builds up the game field.

function jubatian_breakout_Game(level,lives,score)
{
 this.level=level;
 this.lives=lives;
 this.score=score;
 this.scoreml=1;   // Score multiplier
 this.info=new jubatian_breakout_Info();
 this.info.score(score);
 this.info.help("Click to start!");
 this.htype=1;
 var ldf=lives-jubatian_breakout_lifebar_array.length;
 if (ldf) for (var i=0; i<ldf; i++) jubatian_breakout_lifebar_add();
 this.ballno=1; // Number of balls on field
 this.bonus=new Array();
 this.field=new jubatian_breakout_Playfield(jubatian_breakout_levels[level],this.bonus);
 this.paddles=new Array();
 this.paddles[0]=new jubatian_breakout_Paddle(256,374,64);
 this.balls=new Array();
 this.balls[0]=new jubatian_breakout_Ball(this.paddles[0]);
 this.missiles=new Array();
 this.bomb=false;
 this.rocket=false;
 this.status=new Array(); // Booleans indicating which bonuses are in effect
 for (var i=0; i<20; i++) this.status[i]=false;
 this.speed=2.5+level*0.05; // Base speed. Multiply with 100 for pixels per second.
 if (this.speed>5) this.speed=5;
 this.cs=this.speed; // Current speed (As modified by bonuses)
 this.update();
}


// Score increment. This properly applies the scoring multiplier.
function jubatian_breakout_Game_scadd(add)
{ this.score+=Math.floor(add*this.scoreml); this.info.score(this.score); }
jubatian_breakout_Game.prototype.scadd=jubatian_breakout_Game_scadd;


// Removes game - properly clears up all
// If lf is true, also clears up life bar
function jubatian_breakout_Game_remove(lf)
{
 this.field.remove();
 this.info.remove();
 for (var i=0; i<this.balls.length; i++) this.balls[i].remove();
 for (var i=0; i<this.bonus.length; i++) this.bonus[i].remove();
 for (var i=0; i<this.paddles.length; i++) this.paddles[i].remove();
 for (var i=0; i<this.missiles.length; i++) this.missiles[i].remove();
 for (var i=0; i<this.status.length; i++) jubatian_breakout_bonusbar_rem(i);
 if (this.bomb) this.bomb.remove();
 if (this.rocket) this.rocket.remove();
 if (lf) while(jubatian_breakout_lifebar_rem());
}
jubatian_breakout_Game.prototype.remove=jubatian_breakout_Game_remove;


// Re - positions moving objects (paddle, balls, falling bonuses)
function jubatian_breakout_Game_update(){
 for (var i=0; i<this.paddles.length;  i++) this.paddles[i].update();
 for (var i=0; i<this.missiles.length; i++) this.missiles[i].update();
 for (var i=0; i<this.balls.length;    i++) this.balls[i].update();
 for (var i=0; i<this.bonus.length;    i++) this.bonus[i].update();
 if (this.bomb) this.bomb.update();
 if (this.rocket) this.rocket.update();
 jubatian_breakout_lifebar_frame();
 jubatian_breakout_bonusbar_frame();
}
jubatian_breakout_Game.prototype.update=jubatian_breakout_Game_update;


// Bounces a ball on the paddle (Sets starting velocity, either at firing or
// bouncing back). Speed changes are impemented in the game engine, these are
// just reference speeds.

function jubatian_breakout_Game_bounce(ball,paddle){
 // Calculate a fire angle
 var angle=(ball.x-paddle.x)/paddle.w;
 if (angle<-0.5) angle=-0.5; else if (angle>0.5) angle=0.5;
 angle*=3;
 ball.vx=Math.sin(angle);
 ball.vy=-Math.cos(angle);
 ball.y=paddle.bally(); // Y attach (Fire back)
}
jubatian_breakout_Game.prototype.bounce=jubatian_breakout_Game_bounce;


// Ball movement logic - processed in 4 runs for accuracy (This was easier
// than doing exact calculations, the result is the same)

function jubatian_breakout_Game_ball_logic(){

 for (var i=0; i<this.balls.length; i++){
  if (this.balls[i].a) if (!this.balls[i].attach){

   var vx=this.balls[i].vx*this.cs;
   var vy=this.balls[i].vy*this.cs;
   var vxo=vx;
   var vyo=vy;
   var tx=this.balls[i].x+vx;
   var ty=this.balls[i].y+vy;
   
   // Collide with borders
   if (tx<0){ tx=0; vx=-vx; }else if (tx>=512){ tx=511; vx=-vx; }
   if (ty<0){ ty=0; vy=-vy; }else if (ty>=384){
    this.balls[i].remove();
    this.ballno--;
   }
   
   // Collision detection with walls & clearing
   var px=Math.floor(tx/32);
   var py=Math.floor(ty/16);
   var b=this.field.get(px,py);
   if (b) if (b.type){ // Collide
   
    var ht=b.hit();
    if (ht) this.scadd(25);

    if (!ht || !this.status[6]){
    
     var bt=this.field.get(px,py-1); if(bt){ if(bt.type) bt=true; else bt=false; }
     var bb=this.field.get(px,py+1); if(bb){ if(bb.type) bb=true; else bb=false; }
     var bl=this.field.get(px-1,py); if(bl){ if(bl.type) bl=true; else bl=false; }
     var br=this.field.get(px+1,py); if(br){ if(br.type) br=true; else br=false; }
     
     if      (vy==0) vx=-vx;
     else if (vx==0) vy=-vy;
     else if ((vy<0) && (vx<0)){
      var dx=(tx-((px+1)*32))/vx; var dy=(ty-((py+1)*16))/vy; if ((dx<dy) && !br) vx=-vx; else if(!bb) vy=-vy; else vx=-vx; }
     else if ((vy<0) && (vx>0)){
      var dx=(tx-( px   *32))/vx; var dy=(ty-((py+1)*16))/vy; if ((dx<dy) && !bl) vx=-vx; else if(!bb) vy=-vy; else vx=-vx; }
     else if ((vy>0) && (vx<0)){
      var dx=(tx-((px+1)*32))/vx; var dy=(ty-( py   *16))/vy; if ((dx<dy) && !br) vx=-vx; else if(!bt) vy=-vy; else vx=-vx; }
     else if ((vy>0) && (vx>0)){
      var dx=(tx-( px   *32))/vx; var dy=(ty-( py   *16))/vy; if ((dx<dy) && !bl) vx=-vx; else if(!bt) vy=-vy; else vx=-vx; }

    }
     
   }
   
   // Collision with paddles
   var j=0;
   for (; j<this.paddles.length; j++) if (this.paddles[j].a) if (this.paddles[j].collide(tx,ty)){
    if (this.status[3]){ this.balls[i].pattach(this.paddles[j]); break; }
    this.bounce(this.balls[i],this.paddles[j]);
    this.scadd(1);
    break;
   }
   if (j<this.paddles.length) continue;
  
   if (vxo!=vx) this.balls[i].vx=-this.balls[i].vx;
   if (vyo!=vy) this.balls[i].vy=-this.balls[i].vy;
   this.balls[i].x=tx;
   this.balls[i].y=ty;
  }
 }
}
jubatian_breakout_Game.prototype.ball_logic=jubatian_breakout_Game_ball_logic;


// Main game logic (Called every 1/25th second)
// mx, my and mc are mouse coordinates & click status (true if clicked last time)
// Returns 0 if nothing in particular happened, game is going.
// Returns -1 if player ran out of lives (Game over condition).
// Returns no. of lives+1 (0 additional lives is valid!) if player succesfully
// cleared the level.

function jubatian_breakout_Game_frame(mx,my,mc){

 // Paddle movement
 var mxc=mx-jubatian_breakout_res.pfx;
 if (this.status[10]) mxc=512-mxc;
 this.paddles[0].x=mxc;
 this.paddles[0].y=my-jubatian_breakout_res.pfy;
 if (this.paddles[0].x<    (this.paddles[0].w/2)) this.paddles[0].x=    (this.paddles[0].w/2);
 if (this.paddles[0].x>511-(this.paddles[0].w/2)) this.paddles[0].x=511-(this.paddles[0].w/2);
 if (this.paddles[0].y<330) this.paddles[0].y=330;
 if (this.paddles[0].y>374) this.paddles[0].y=374;

 // Release balls on click & do not allow more than 1 ball on the paddle
 var batt=false;
 for (var i=0; i<this.balls.length; i++) if (this.balls[i].attach){
  if ((this.htype>2) || (this.htype==0)){ this.info.help("Click to release!"); this.htype=2; }
  if (mc || batt){
   this.balls[i].release();
   this.bounce(this.balls[i],this.paddles[0]);
  }
  batt=true;
 }
 
 // Change score multiplier according to ball attach status
 // (Attached ball degrades scoring until halving it. 10 seconds degrade / improve back)
 if (batt){
  if (this.scoreml>0.5) this.scoreml-=0.002;
 }else{
  if (this.scoreml<1)   this.scoreml+=0.002;
 }
 
 // Check for bomb / rocket availability & set help messages
 var rbomb=false;
 var rrock=false;
 if ((this.status[11]) && ((!this.bomb)   || (!this.bomb.a  ))) rbomb=true;
 if ((this.status[12]) && ((!this.rocket) || (!this.rocket.a))) rrock=true;
 if (!batt){
  if      (rrock){ if (this.htype!=5){ this.info.help("Click for rocket!"); this.htype=5; }}
  else if (rbomb){ if (this.htype!=4){ this.info.help("Click to bomb!"); this.htype=4; }}
  else if (this.status[5]){ if (this.htype!=3){ this.info.help("Click to shoot!"); this.htype=3; }}
  else{ this.info.help(""); this.htype=0; }
 }
 
 // Fire rocket / bomb / missile if any
 if (!batt && mc){
  if (rrock){
   this.rocket=new jubatian_breakout_Rocket(this.paddles[0]);
   this.status[12]=false;
   jubatian_breakout_bonusbar_rem(12);
  }else if(rbomb){
   this.bomb=new jubatian_breakout_Bomb(this.paddles[0]);
   this.status[11]=false;
   jubatian_breakout_bonusbar_rem(11);
  }else if (this.status[5]){
   this.missiles[jubatian_breakout_free(this.missiles)]=new jubatian_breakout_Missile(this.paddles[0],true);
   this.missiles[jubatian_breakout_free(this.missiles)]=new jubatian_breakout_Missile(this.paddles[0],false);
  }
 }
 
 // Paddle animation (shrink / grow if appropriate)
 for (var i=0; i<this.paddles.length; i++) this.paddles[i].frame();
 
 // Rocket
 if ((this.rocket) && (this.rocket.a)){
  this.rocket.y-=16;
  if (this.rocket.y<0) this.rocket.remove();
  else{
   var px=Math.floor(this.rocket.x/32);
   var py=Math.floor(this.rocket.y/16);
   var b=this.field.get(px,py);
   if (b) if (b.type){
    if(b.hit(3)) this.scadd(25);
    else this.rocket.remove();
   }
  }
 }  
 
 // Bomb
 if ((this.bomb) && (this.bomb.a)){
  this.bomb.y-=3;
  var px=Math.floor(this.bomb.x/32);
  var py=Math.floor(this.bomb.y/16);
  var b=this.field.get(px,py);
  if ((this.bomb.y<0) || ((b) && (b.type))){
   var hitarr=new Array(0,1,1,1,0, 0,1,1,1,0, 1,1,2,1,1, 1,2,2,2,1, 1,2,3,2,1, 1,2,2,2,1, 1,1,2,1,1, 0,1,1,1,0, 0,1,1,1,0);
   for (var i=-2; i<=2; i++) for(var j=-4; j<=4; j++) if(hitarr[(i+2)+(j+4)*5]){
    b=this.field.get(px+i,py+j);
    if (b) if (b.type) if(b.hit(hitarr[(i+2)+(j+4)*5])) this.scadd(25);
   }
   this.bomb.remove();   
  }
 }
 
 // Missiles
 for (var i=0; i<this.missiles.length; i++) if(this.missiles[i].a){
  this.missiles[i].y-=15;
  if (this.missiles[i].y<0){ this.missiles[i].remove(); continue; }
  var px=Math.floor(this.missiles[i].x/32);
  var py=Math.floor(this.missiles[i].y/16);
  var b=this.field.get(px,py);
  if (b) if (b.type){ if(b.hit(1)){ this.scadd(25); } this.missiles[i].remove(); }
 }
 
 // Balls
 this.ball_logic();
 this.ball_logic();
 this.ball_logic();
 this.ball_logic();
 
 // Check for life take condition
 if (!this.ballno){
  if (jubatian_breakout_lifebar_rem()){
   this.balls[jubatian_breakout_free(this.balls)]=new jubatian_breakout_Ball(this.paddles[0]);
   this.ballno++;
   if (this.status[9]){ this.cs=this.speed; this.status[9]=false; }
   this.status[10]=false;
   jubatian_breakout_bonusbar_rem(9);  // Remove the two worst
   jubatian_breakout_bonusbar_rem(10);
  }else return -1; // Game over
 }
 
 // Check for level clear condition
 if (!this.field.brickno) return jubatian_breakout_lifebar_array.length+1;
 
 // Drop down bonuses
 for (var i=0; i<this.bonus.length; i++) if (this.bonus[i].a){
  this.bonus[i].frame((this.cs)*1);
  if ((this.bonus[i].y>320) && (this.bonus[i].y<376)){
   for (var j=0; j<this.paddles.length; j++) if (this.paddles[j].a)
    if (this.paddles[j].collide(this.bonus[i].x,this.bonus[i].y)){
    
     switch(this.bonus[i].type){ // Bonus - specific action
     
      case 0: // Remove reds
       if (this.status[8]){ this.paddles[j].size(64); this.status[8]=false; }
       if (this.status[9]){ this.cs=this.speed;       this.status[9]=false; }
       this.status[10]=false;
       jubatian_breakout_bonusbar_rem(8);
       jubatian_breakout_bonusbar_rem(9);
       jubatian_breakout_bonusbar_rem(10);
       this.scadd(100);
       break;
       
      case 1:  // New ball
       this.balls[jubatian_breakout_free(this.balls)]=new jubatian_breakout_Ball(this.paddles[0]);
       this.ballno++;
       this.scadd(50);
       break;
       
      case 2:  // Paddle size increase
       if     ( this.status[8]){ this.paddles[j].size(64); this.status[8]=false; jubatian_breakout_bonusbar_rem(8); }
       else if(!this.status[2]){ this.paddles[j].size(84); this.status[2]=true;  jubatian_breakout_bonusbar_add(2); }
       this.scadd(20);
       break;
       
      case 3:  // Ball attach
       this.status[3]=true; jubatian_breakout_bonusbar_add(3);
       this.scadd(40);
       break;
       
      case 4:  // Slow
       if     ( this.status[9]){ this.cs=this.speed;      this.status[9]=false; jubatian_breakout_bonusbar_rem(9); }
       else if(!this.status[4]){ this.cs=this.speed*0.75; this.status[4]=true;  jubatian_breakout_bonusbar_add(4); }
       this.scadd(60);
       break;
       
      case 5:  // Shoot
       this.status[5]=true; jubatian_breakout_bonusbar_add(5);
       this.scadd(200);
       break;
       
      case 6:  // Super ball
       this.status[6]=true; jubatian_breakout_bonusbar_add(6);
       this.scadd(200);
       break;
       
      case 7:  // Remove greens
       if ( this.status[2]){ this.paddles[j].size(64); this.status[2]=false; }
       if ( this.status[4]){ this.cs=this.speed;       this.status[4]=false; }
       this.status[3]=false;
       this.status[5]=false;
       this.status[6]=false;
       jubatian_breakout_bonusbar_rem(2);
       jubatian_breakout_bonusbar_rem(3);
       jubatian_breakout_bonusbar_rem(4);
       jubatian_breakout_bonusbar_rem(5);
       jubatian_breakout_bonusbar_rem(6);
       break;
       
      case 8:  // Paddle size shrink
       if     ( this.status[2]){ this.paddles[j].size(64); this.status[2]=false; jubatian_breakout_bonusbar_rem(2); }
       else if(!this.status[8]){ this.paddles[j].size(50); this.status[8]=true;  jubatian_breakout_bonusbar_add(8); }
       break;
       
      case 9:  // Fast
       if     ( this.status[4]){ this.cs=this.speed;      this.status[4]=false; jubatian_breakout_bonusbar_rem(4); }
       else if(!this.status[9]){ this.cs=this.speed*1.25; this.status[9]=true;  jubatian_breakout_bonusbar_add(9); }
       break;
       
      case 10: // Invert controls
       if (!this.status[10]){ this.status[10]=true; jubatian_breakout_bonusbar_add(10); }else{ this.status[10]=false; jubatian_breakout_bonusbar_rem(10); }
       break;
       
      case 11: // Give a bomb
       this.status[11]=true; jubatian_breakout_bonusbar_add(11);
       this.scadd(200);
       break;

      case 12: // Give a rocket
       this.status[12]=true; jubatian_breakout_bonusbar_add(12);
       this.scadd(200);
       break;
       
      default:;
     }    
    
     this.bonus[i].remove();
    }
  }
  if (this.bonus[i].y>376) this.bonus[i].remove();
 }

 // Process frame - move the objects
 this.update();

 return 0;
}
jubatian_breakout_Game.prototype.frame=jubatian_breakout_Game_frame;

























var jubatian_breakout_timer;
var jubatian_breakout_hiscore=0;
var jubatian_breakout_score=0;
var jubatian_breakout_level=0;
var jubatian_breakout_lives=0;
var jubatian_breakout_status=0;

function jubatian_breakout_init(){
 // Hide, but make sure they load...
 $("#jubatian_breakout_blocks, #jubatian_breakout_objects, #jubatian_breakout_logo, #jubatian_breakout_bg").css({position: "absolute", width: "0px", height: "0px"});
 $("#jubatian_breakout").css(jubatian_breakout_res.clearcss);
 $("#jubatian_breakout").css({position: "relative", width: "640px", height: "400px",
  zIndex: jubatian_breakout_zbase});
 $("#jubatian_breakout").append('<div id="jubatian_breakout_interface"></div>');
 $("#jubatian_breakout_interface").css(jubatian_breakout_res.clearcss);
 $("#jubatian_breakout_interface").css({position: "absolute", width: "640px", height: "400px",
  zIndex: (jubatian_breakout_zbase+7), left: "0px", top: "0px"});
 $("#jubatian_breakout_interface").click(jubatian_breakout_iclick);
 $("#jubatian_breakout_interface").mousemove(jubatian_breakout_imove);
 jubatian_breakout_res.img() // Init image resources
 $("#jubatian_breakout").css({backgroundImage: "url('"+jubatian_breakout_res.logo+"')", backgroundPosition: "0px 0px"});
 $("#jubatian_breakout").append('<div id="jubatian_breakout_info"></div>');
 $("#jubatian_breakout_info").css(jubatian_breakout_res.clearcss);
 $("#jubatian_breakout_info").css({position: "absolute", width: "640px", height: "50px",
  left: "0px", top: "310px", textAlign: "center", fontSize: "12px", color: "#dddddd"});
 $("#jubatian_breakout_info").text("Loading...");
 jubatian_breakout_timer=window.setInterval(jubatian_breakout_load,1000);
}



// Loading... (Wait for images to download)
function jubatian_breakout_load(){
 var img=$("#jubatian_breakout_blocks, #jubatian_breakout_objects").get();
 var load=1;
 for (var i=0; i<img.length; i++) if (!img[i].complete) load=0;
 if (load){
  window.clearInterval(jubatian_breakout_timer);
  $("#jubatian_breakout_info").text("Click to play!");
  jubatian_breakout_status=0;
  jubatian_breakout_timer=window.setInterval(jubatian_breakout_play,40);
 }
}



var jubatian_breakout_mx=0;  // Mouse variables
var jubatian_breakout_my=0;
var jubatian_breakout_mc=0;  // Clicked status



// Mouse event handlers

function jubatian_breakout_iclick(){ jubatian_breakout_mc=1; }
function jubatian_breakout_imove(e){
 var coff=$("#jubatian_breakout").offset();
 jubatian_breakout_mx=e.pageX-coff.left;
 jubatian_breakout_my=e.pageY-coff.top;
}



// Playing

function jubatian_breakout_play(){

 switch(jubatian_breakout_status){
 
  case 0: // Logo displayed, wait for click
  
   if(jubatian_breakout_mc){
    jubatian_breakout_status=1;
    jubatian_breakout_score=0;
    jubatian_breakout_level=0;
    jubatian_breakout_lives=3;
    $("#jubatian_breakout_info").text("");
    jubatian_breakout_game=new jubatian_breakout_Game(jubatian_breakout_level,jubatian_breakout_lives,jubatian_breakout_score);
    $("#jubatian_breakout").css({backgroundImage: "url('"+jubatian_breakout_res.bg+"')"});
   }
   break;
   
  case 2: // Entering new level

   if(jubatian_breakout_mc){
    jubatian_breakout_status=1;
    $("#jubatian_breakout_info").text("");
    jubatian_breakout_game=new jubatian_breakout_Game(jubatian_breakout_level,jubatian_breakout_lives,jubatian_breakout_score);
    $("#jubatian_breakout").css({backgroundImage: "url('"+jubatian_breakout_res.bg+"')"});
   }
   break;
   
  case 1: // Playing game

   var rt=jubatian_breakout_game.frame(jubatian_breakout_mx,jubatian_breakout_my,jubatian_breakout_mc);
   if (rt){ // Level ended (either lives lost or level clear)

    jubatian_breakout_score=jubatian_breakout_game.score;
    jubatian_breakout_game.remove(true);

    var end=false;
    var str="";
    if (rt<0){
     end=true;
     str+="Game over!<br />";
    }else{
     jubatian_breakout_level++;
     if (!jubatian_breakout_levels[jubatian_breakout_level]){
      end=true;
      str+="You beat this shitty game! Well done!<br />";
     }
    }

    if(end){ // End the game
     if (jubatian_breakout_score>jubatian_breakout_hiscore){
      jubatian_breakout_hiscore=jubatian_breakout_score;
      str+="You set new high score: ";
     }else{
      str+="Your score: ";
     }
     str+=jubatian_breakout_score;
     str+="<br />Click to start a new game!";
     $("#jubatian_breakout_info").html(str);
     $("#jubatian_breakout").css({backgroundImage: "url('"+jubatian_breakout_res.logo+"')"});
     jubatian_breakout_status=0;
     break;
    }
    
    // Next level screen
    str="Level clear!";
    if ((jubatian_breakout_level%3)==0){
     str+=" You gained an extra life!";
     rt++;
    }
    str+="<br />Score: "+jubatian_breakout_score+", Lives: "+(rt-1);
    str+="<br />Click to enter level "+(jubatian_breakout_level+1)+"!";
    $("#jubatian_breakout_info").html(str);
    jubatian_breakout_lives=rt-1;
    jubatian_breakout_status=2;
    $("#jubatian_breakout").css({backgroundImage: "url('"+jubatian_breakout_res.logo+"')"});

   }
   break;
   
  default:;
 }
 
 jubatian_breakout_mc=0;
}


jubatian_breakout_init(); // Start!

}